#INTRODUCTION
#DIVISER POUR MIEUX REGNER
#Exemple de calcul d'une puissance

import time

x=2
n=100
repeat=300

def puis_python(x,n):
    return x**n

t1=time.time()
for i in range(repeat):
    #print("** : ", puis_python(x,n))
    puis_python(x,n)
t2=time.time()
print("** : ", t2-t1)


def puissance_recursive(x,n):
    pass

'''
t1=time.time()
for i in range(repeat):
    #print("recursive : ", puissance_recursive(x,n))
    puissance_recursive(x,n)
t2=time.time()
print("recursive : ", t2-t1)
'''


def puissance_dpmr(x,n):
    pass

'''
t1=time.time()
for i in range(repeat):
    #print("diviser V1 :" ,puissance_dpmr(2,n))
    puissance_dpmr(x,n)
t2=time.time()
print("diviser V1 :" ,t2-t1)
'''



def puissance_dpmr_memo(x,n,mem):#mem est un dictionnaire
    if n in mem:
        return mem[n]
    elif n==0:
        mem[n]=1
        return mem[n]
    elif n%2==0:
        mem[n]=  puissance_dpmr_memo(x,(n/2),mem)*puissance_dpmr_memo(x,(n/2),mem)
        return mem[n]
    else :
        mem[n]=x*puissance_dpmr_memo(x,(n-1)/2,mem)*puissance_dpmr_memo(x,(n-1)/2,mem)
        return mem[n]
    
'''
t1=time.time()
for i in range(repeat):
    #print("diviser mémo : ", puissance_dpmr_memo(2,n,{}))
    puissance_dpmr_memo(x,n,{})
t2=time.time()
print("diviser mémo : ", t2-t1)
'''











# Chercher un élément dans une liste triée
L=range(0,10000)
print("")

#Recherche Python

def search0(L,elt):
    return elt in L

t1=time.time()
for i in range(repeat):
    #print("recheche python : ", -1 in L)
    search0(L,-1)
t2=time.time()
print("recherche python : ",t2-t1)

# Recherche naïve

def searchV1(L,elt):
    for i in L:
        if i==elt:
            return True
    return False


t1=time.time()
for i in range(repeat):
    #print("recheche naïve : ", searchV1(L,elt))
    searchV1(L,-1)
t2=time.time()
print("recherche naïve : ",t2-t1)



# Recherche par dichotomie


def searchV2(L,elt):
    a=0
    b=len(L)-1
    m=(b-a)//2
    while m!=0:
        if elt==m:
            return True
        elif elt>m:
            a=m
        else:
            b=m
        m=(b-a)//2
    return False


t1=time.time()
for i in range(repeat):
    #print("recheche dichoto : ", searchV2(L,-1))
    searchV2(L,-1)
t2=time.time()
print("recherche dichoto : ",t2-t1)



# Recherche par dichotomie recurssif


def searchV2_recur(L,elt):
    m=len(L)//2
    if m==0:
        return False
    else :
        if L[m]==elt:
            return True
        elif elt>L[m]:
            return searchV2_recur(L[m::],elt)
        else:
            return searchV2_recur(L[0:m],elt)



t1=time.time()
for i in range(repeat):
    #print("recheche dichoto : ", searchV2(L,-1))
    searchV2_recur(L,-1)
t2=time.time()
print("recherche dichoto_recur : ",t2-t1)




#Algorithme de trie

#DIVISER POUR MIEUX REGNER 

import time
import random
repeat=300


L=[k for  k in range(700)]
random.shuffle(L) #On melange L

#Trie par insertion


def permuter(L,i,j):
    """
    permute les elements d'indice i et j de L
    exemple :
    >>>permuter([12,7,8,45],1,2)
    [12,8,7,45]
    """
    tmp=L[i]
    L[i]= L[j]
    L[j]=tmp
    return L
    


def tri_insert(L):
    """
    Tri par insersion la liste L
    >>>tri_insert([12,7,8,45])
    [7,8,12,45]
    """
    for i in range(1, len(L)):  
        k=i
        while  k>0 and  L[k-1]>L[k]:
            permuter(L,k-1,k)
            k=k-1
         
    return L


#Tester le code ci-dessous :

time1=time.time() 
tri_insert(L)
time2=time.time()
print("temps insertion : ",time2-time1, "seconde(s)")
random.shuffle(L) #on remelange L


#Trie par selection


def minimum(L,a):
    """
    :param l: (list) une liste
    :param a, b: (int) deux indices
    :param comp: (fonction) [optionnel] une fonction de comparaison
                   Valeur par défaut compare
    :return: (int) l'indice du minimum dans la tranche l[a:len(l)]
    :Exemples:
    
    >>> select_min([1, 2, 0, 4, 5, 6, 7, 3], 0)
    7
    >>> select_min([1, 2, 0, 4, 5, 6, 7, 3], 3)
    3
    """
    ind_min=a
    for i in range(a+1,len(L)):
        if L[i] < L[ind_min] :
            ind_min=i
    return ind_min	
	

#MISE EN PLACE DU TRI PAR SELECTION 

def select_sort(L):
    n = len(L)
    # la tranche l[0:1] est triée
    for i in range(n - 1):
        # supposons la tranche l[0:i+1] triée
        ind_min = minimum(L, i)
        permuter(L, i, ind_min)
    return L


#Tester le code ci-dessous :

time1=time.time() 
select_sort(L)
time2=time.time()
print("temps selection : ",time2-time1, "seconde(s)")
random.shuffle(L) #on remelange L





def trifusion(T):
    if len(T)<=1:
        return T
    else:
        T1=T[:len(T)//2]
        #print(T1)
        T2=T[len(T)//2:]
        #print(T2)
        return fusion(trifusion(T1),trifusion(T2))
    
def fusion(T1,T2):
    if T1==[]:
        return T2
    elif T2==[]:
        return T1
    elif T1[0]<T2[0]:
        return [T1[0]]+fusion(T1[1:],T2)
    else:
        return [T2[0]]+fusion(T1,T2[1:])
    

time1=time.time() 
trifusion(L)
time2=time.time()
print("temps fusion : ",time2-time1, "seconde(s)")








'''
def fibo(n):
    """Version récursive naïve"""
    if n <= 1:
        return n
    else:
        return fibo(n-1) + fibo(n-2)

t1=time.time()
print("fiboV1 : ", fibo(30))
t2=time.time()
print(t2-t1) 


    
def fibo_memo(n, memo):
    if n in memo:      # si calcul déjà effectué
        return memo[n] # on renvoie directement sa valeur
    elif n <= 1:
        memo[n] = n
        return memo[n]
    else:
        memo[n] = fibo_memo(n-1, memo) + fibo_memo(n-2, memo)
        return memo[n]
    
t1=time.time()
print("fibo V2 : " ,fibo_memo(30,{}))
t2=time.time()
print(t2-t1)
'''